<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Pracovisko\PocetKontrolPodlaDruhuAHodnotenia;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use InvalidArgumentException;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\EChartSourceItemContract;

/**
 * Class PocetKontrolPodlaDruhuAHodnoteniaEChartSourceItem
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Pracovisko\PocetKontrolPodlaDruhuAHodnotenia
 */
final class PocetKontrolPodlaDruhuAHodnoteniaEChartSourceItem implements EChartSourceItemContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var int
     */
    protected int $pocet = 0;
    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum
     */
    private DruhEmisnejKontrolyEnum $druhEmisnejKontroly;
    /**
     * @var array
     */
    private array $hodnotenia = [];

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum $druhEmisnejKontroly
     */
    public function __construct(DruhEmisnejKontrolyEnum $druhEmisnejKontroly)
    {
        $this->druhEmisnejKontroly = $druhEmisnejKontroly;

        foreach (HodnotenieEmisnejKontrolyEnum::cases() as $case) {
            $this->hodnotenia[$case->value] = 0;
        }
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia): self
    {
        if (!$this->druhEmisnejKontroly->equal($pocetKontrolPodlaDruhuAHodnotenia->druh())) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa druh emisnej kontroly %s, vstupny atribut obsahuje druh emisnej kontroly %s',
                $this->druhEmisnejKontroly->label(),
                $pocetKontrolPodlaDruhuAHodnotenia->druh()->label()
            ));
        }

        $this->hodnotenia[$pocetKontrolPodlaDruhuAHodnotenia->hodnotenie()->value] = $pocetKontrolPodlaDruhuAHodnotenia->pocet();
        $this->pocet += $pocetKontrolPodlaDruhuAHodnotenia->pocet();

        return $this;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum $druhEmisnejKontroly
     * @param array                                                                       $hodnotenia
     *
     * @return void
     */
    public function incrementData(DruhEmisnejKontrolyEnum $druhEmisnejKontroly, array $hodnotenia)
    {
        if (!$this->druhEmisnejKontroly->equal($druhEmisnejKontroly)) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa druh emisnej kontroly %s, vstupny atribut obsahuje druh emisnej kontroly %s',
                $this->druhEmisnejKontroly->label(),
                $druhEmisnejKontroly->label()
            ));
        }

        foreach ($this->hodnotenia as $k => $v) {
            if (array_key_exists($k, $hodnotenia)) {
                $this->hodnotenia[$k] += $hodnotenia[$k];
                $this->pocet += $hodnotenia[$k];
            }
        }
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum
     */
    public function druhEmisnejKontroly(): DruhEmisnejKontrolyEnum
    {
        return $this->druhEmisnejKontroly;
    }

    /**
     * @return array
     */
    public function hodnotenia(): array
    {
        return $this->hodnotenia;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return array_merge(
            [
                'druh' => $this->druhEmisnejKontroly->value,
                'label' => $this->druhEmisnejKontroly->label(),
                'pocet' => $this->pocet,
            ],
            $this->hodnotenia,
        );
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
